<?php
/*
Plugin Name: Twitter Hash Tag Shortcode
Plugin URI: http://en.bainternet.info
Description: Displaying the most recent twitter status updates for a particular hash tag in your posts/pages using shortcode.
Version: 0.5
Author: bainternet
Author URI: http://www.bainternet.info
*/
/*  Copyright 2012  - 2013 Ohad Raz  (email : admin@bainternet.info)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
* tweets_by_hashtag class
*/
class tweets_by_hashtag{
    /**
     * __construct 
     * 
     * Class constructor
     * @since   0.5
     * @author  Ohad      Raz   <admin@bainternet.info>
     * @return Void
     */
    function __construct(){
        add_filter( 'plugin_row_meta', array($this ,'ba_tweets_my_plugin_links'), 10, 2 );
        add_shortcode("hashtag_tweets",  array($this ,"ba_tweets_by_hashtag_9867"));
    }

    function ba_tweets_my_plugin_links($links, $file) {  
        $plugin = plugin_basename(__FILE__);  
      
        if ($file == $plugin) // only for this plugin  
            return array_merge( $links,  
                array( '<a href="http://en.bainternet.info/category/plugins">' . __('Other Plugins by this author' ) . '</a>' ),  
                array( '<a href="http://wordpress.org/tags/twitter-hash-tag-shortcode?forum_id=10">' . __('Plugin Support') . '</a>' ),  
                array( '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=K4MMGF5X3TM5L" target="_blank">' . __('Donate') . '</a>' )  
            );  
        return $links;  
    }

    /**
     * ba_tweets_by_hashtag_9867
     * 
     * shortcode handler funciton 
     * 
     * [hashtag_tweets hashtag="YOUR_TAG" number="NUMBER_OF_TWEETS_TO_GET" images="on/off" cache="number of hours to cache output"]
     * 
     * example:
     *     [hashtag_tweets hashtag="bainternetsites" number="5" cache="5"]  
     */
    function ba_tweets_by_hashtag_9867($atts, $content = null){
        extract(shortcode_atts(array(
            "hashtag" => 'default_tag',
            "number" => 5,
            "cache" => 3,
            "images" => "on"
        ), $atts));
        $api_url = 'http://search.twitter.com/search.json';
        $raw_response = wp_remote_get("$api_url?q=%23$hashtag&rpp=$number");
        $output = get_transient( 'tweets_has_'. $hashtag);
        if ( false === $output ) {
            if ( is_wp_error($raw_response) ) {
                $output = "<p>".__("Failed to update from Twitter!")."</p>\n";
                $output .= "<!--{$raw_response->errors['http_request_failed'][0]}-->\n";
            } else {
                if ( function_exists('json_decode') ) {
                    $response = get_object_vars(json_decode($raw_response['body']));
                    for ( $i=0; $i < count($response['results']); $i++ ) {
                        $response['results'][$i] = get_object_vars($response['results'][$i]);
                    }
                } else {
                    include(ABSPATH . WPINC . '/js/tinymce/plugins/spellchecker/classes/utils/JSON.php');
                    $json = new Moxiecode_JSON();
                    $response = @$json->decode($raw_response['body']);
                }

                $output = "<div class='twitter-hash-tag'>\n";
                foreach ( $response['results'] as $result ) {
                    $text = $result['text'];
                    $user = $result['from_user'];
                    $image = $result['profile_image_url'];
                    $user_url = "http://twitter.com/$user";
                    $source_url = "$user_url/status/{$result['id']}";

                    $text = preg_replace('|(https?://[^\ ]+)|', '<a href="$1">$1</a>', $text);
                    $text = preg_replace('|@(\w+)|', '<a href="http://twitter.com/$1">@$1</a>', $text);
                    $text = preg_replace('|#(\w+)|', '<a href="http://search.twitter.com/search?q=%23$1">#$1</a>', $text);

                    $output .= "<div>";

                    if ( isset($image) &&  $images == "on")
                        $output .= "<a href='$user_url'><img src='$image' alt='$user' /></a>";
                    $output .= "<a href='$user_url'>$user</a>: $text <a href='$source_url'>&raquo;</a></div>\n";
                }
                $output .= "<div class='view-all'><a href='http://search.twitter.com/search?q=%23$hashtag'>" . __('View All') . "</a></div>\n";
                $output .= "</div>\n";
                //store as transients
                set_transient( 'tweets_has_'. $hashtag, $output, 60*60*absint($cache) );
            }
        }
        

        return $output;
    }
}//end class
new tweets_by_hashtag();